<?php

namespace FM\Factory;

use Doctrine\ORM\EntityManager;
use Teknisa\Model\Traits\TQuery;

class FmIntegracaoHcmFactory
{
    use TQuery;

    protected $connection;
    protected $entityManager;

    public function __construct(EntityManager $entityManager)
    {
        $this->connection = $entityManager->getConnection();
        $this->entityManager = $entityManager;
    }

    public function getTarefasMapaOperacao($parametros, $listaOperadores)
    {
        $sql = "SELECT
                    FCM_CHECKLISTAGEND.NRCHECKLISTAGEND,
                    FCM_CHECKLISTAGEND.NMCHECKLISTAGEND, 
                    TO_CHAR(FCM_CHECKLISTAGEND.DTHORAAGEND, 'DD/MM/YYYY HH24:MI') AS DTHORAAGEND,
                    TO_CHAR(FCM_CHECKLISTAGEND.DTHRFINALAGEND, 'DD/MM/YYYY HH24:MI') AS DTHRFINALAGEND,
                    TO_CHAR(FCM_CHECKLISTAGEND.DTINCLUSAO, 'DD/MM/YYYY HH24:MI:SS') AS DTINCLUSAO,
                    ROUND(24 *(60 *(FCM_CHECKLISTAGEND.DTHRFINALAGEND - FCM_CHECKLISTAGEND.DTHORAAGEND)), 2) AS DURACAO,
                    FCM_LOCALCLI.NRLOCALCLIENTE, 
                    FCM_LOCALCLI.NMLOCALCLIENTE, 
                    FCM_LOCALCLI.NRESTRUTURAM,
                    FCM_TIPOLOCALCLI.NRTIPOLOCALCLI,
                    FCM_TIPOLOCALCLI.NMTIPOLOCALCLI, 
                    FCT_CONTRATO.NRSEQCONTRATO,
                    FCM_CHECKLIST.NRCHECKLIST, 
                    FCM_CHECKLIST.NMCHECKLIST, 
                    FCM_CHECKLISTAGEND.IDTIPORECORRENCIA, 
                    FCM_CHECKLISTAGEND.IDSITUACAOAGEND,
                    FCM_CHECKLISTAGEND.CDOPERINCLUSAO,
                    OPERADOR.NMOPERADOR, 
                    FCM_CHECKLISTAGEND.CDOPERADOR, 
                    FCM_EQUIPE.NMEQUIPE,
                    FCM_EQUIPETAREFA.NREQUIPE,
                    FCM_EQUIPETAREFA.NREQUIPETAREFA,
                    FCM_LOCALCLI.CDCLIENTE, 
                    CLIENTE.NMRAZSOCCLIE,
                    CLIENTE.NMFANTCLIE,
                    CLIENTE.NRPARCNEGOCIO,
                    FCT_CONTRATO.NRCONTRATOFCT, 
                    FCM_CHECKLISTAGEND.IDATIVO, 
                    FCM_GERENCIAMENTOCHK.CDOPERADOR AS CDOPERADORPAI,
                    FCM_GERENCIAMENTOCHK.IDOBRIGAOBSERVACAO,
                    FCM_GERENCIAMENTOCHK.NRGERENCIAMENTOCHK,
                    FCM_CHECKLISTAGEND.IDTIPOMARCACAOTAREFA, 
                    FCM_CHECKLISTAGEND.NRPRIORIDADETAREFA, 
                    FCM_CHECKLISTAGEND.IDTAREFAEQUIPE,
                    FCM_CHECKLISTAGEND.NRESCOPOSTAREFA,
                    FCM_ESCOPOSTAREFA.NMESCOPOSTAREFA,
                    FCM_RELCHKAGENDMODPOP.NRMODELOPOP,
                    FCM_RELCHKAGENDMODPOP.DSOBSERVACAO,
                    FCM_RELCHKAGENDMODPOP.NRRELCHKAGENDMODPOP,
                    FCM_RELACHABOPER.NRHABILIDADE,
                    CASE
                        WHEN SYSDATE < FCM_CHECKLISTAGEND.DTHORAAGEND THEN ' '
                        WHEN FCM_CHECKLISTAGEND.IDSITUACAOAGEND = '2' THEN ' '  
                        WHEN FCM_CHECKLISTAGEND.IDSITUACAOAGEND = '3' THEN ' '
                        WHEN FCM_CHECKLISTAGEND.IDSITUACAOAGEND = '4' THEN ' '
                        WHEN TRUNC(SYSDATE) - TRUNC(FCM_CHECKLISTAGEND.DTHORAAGEND) < 1 THEN GREATEST(FLOOR((SYSDATE - FCM_CHECKLISTAGEND.DTHORAAGEND) * 24), 0) || ' horas ' || GREATEST(FLOOR((SYSDATE - FCM_CHECKLISTAGEND.DTHORAAGEND) * 24 * 60) - (FLOOR((SYSDATE - FCM_CHECKLISTAGEND.DTHORAAGEND) * 24) * 60), 0) || ' minutos'
                        ELSE TRUNC(SYSDATE) - TRUNC(FCM_CHECKLISTAGEND.DTHORAAGEND) || ' dias'
                    END AS ATRASO
                FROM 
                    FCM_CHECKLISTAGEND
                JOIN 
                    FCM_LOCALCLI ON FCM_CHECKLISTAGEND.NRLOCALCLIENTE = FCM_LOCALCLI.NRLOCALCLIENTE
                JOIN 
                    CLIENTE ON CLIENTE.CDCLIENTE = FCM_LOCALCLI.CDCLIENTE
                JOIN 
                    FCM_TIPOLOCALCLI ON FCM_LOCALCLI.NRTIPOLOCALCLI = FCM_TIPOLOCALCLI.NRTIPOLOCALCLI
                JOIN 
                    FCM_CHECKLIST ON FCM_CHECKLISTAGEND.NRCHECKLIST = FCM_CHECKLIST.NRCHECKLIST
                LEFT JOIN 
                    FCM_GERENCIAMENTOCHK ON FCM_GERENCIAMENTOCHK.NRCHECKLISTAGEND = FCM_CHECKLISTAGEND.NRCHECKLISTAGEND
                LEFT JOIN 
                    OPERADOR ON FCM_CHECKLISTAGEND.CDOPERADOR = OPERADOR.CDOPERADOR
                LEFT JOIN 
                    FCT_CONTRATO ON FCT_CONTRATO.NRSEQCONTRATO = FCM_CHECKLISTAGEND.NRSEQCONTRATO
                LEFT JOIN 
                    FCM_EQUIPETAREFA ON FCM_EQUIPETAREFA.NRCHECKLISTAGEND = FCM_CHECKLISTAGEND.NRCHECKLISTAGEND
                LEFT JOIN 
                    FCM_EQUIPE ON FCM_EQUIPE.NREQUIPE = FCM_EQUIPETAREFA.NREQUIPE
                LEFT JOIN 
                    FCM_RELCHKAGENDMODPOP ON FCM_CHECKLISTAGEND.NRCHECKLISTAGEND = FCM_RELCHKAGENDMODPOP.NRCHECKLISTAGEND
                LEFT JOIN 
                    FCM_ESCOPOSTAREFA ON FCM_CHECKLISTAGEND.NRESCOPOSTAREFA = FCM_ESCOPOSTAREFA.NRESCOPOSTAREFA
                LEFT JOIN FCM_RELACHABOPER
                        ON FCM_RELACHABOPER.CDOPERADOR = OPERADOR.CDOPERADOR
                WHERE 
                    ((FCM_CHECKLISTAGEND.CDOPERADOR IN ($listaOperadores)) -- Tarefas criadas para operador específico
                        OR ((FCM_CHECKLISTAGEND.CDOPERADOR IS NULL) AND (FCM_CHECKLISTAGEND.IDTAREFAEQUIPE = 'N')) -- Tarefas sem operador
                        OR (FCM_EQUIPETAREFA.NREQUIPE IN 
                            (SELECT DISTINCT FCM_EQUIPE.NREQUIPE 
                            FROM FCM_EQUIPE
                            JOIN FCM_RELACEQUIPEOPER ON FCM_RELACEQUIPEOPER.NREQUIPE = FCM_EQUIPE.NREQUIPE
                            WHERE FCM_RELACEQUIPEOPER.CDOPERADOR IN ($listaOperadores))) -- Tarefas de equipe
                        OR FCM_CHECKLISTAGEND.CDOPERINCLUSAO = :CDOPERADOR) -- Operador de inclusão
                AND FCM_CHECKLISTAGEND.IDATIVO = 'S'
                    ORDER BY FCM_CHECKLISTAGEND.DTHORAAGEND DESC";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql, $parametros);
    }

    public function getOperadoresDaEquipe($parametros)
    {
        $sql = "SELECT FCM_RELACEQUIPEOPER.NRRELACEQUIPEOPER, FCM_RELACEQUIPEOPER.CDOPERADOR , OPERADOR.NMOPERADOR, OPERADOR.NRPARCNEGOCIO
                FROM FCM_RELACEQUIPEOPER
                 JOIN FCM_EQUIPETAREFA 
                    ON FCM_EQUIPETAREFA.NREQUIPE = FCM_RELACEQUIPEOPER.NREQUIPE
             JOIN OPERADOR           
                    ON FCM_RELACEQUIPEOPER.CDOPERADOR = OPERADOR.CDOPERADOR
                 JOIN PARCNEGOCIO
                    ON PARCNEGOCIO.NRPARCNEGOCIO = OPERADOR.NRPARCNEGOCIO
                WHERE FCM_RELACEQUIPEOPER.NREQUIPE = :NREQUIPE
                AND FCM_EQUIPETAREFA.NRCHECKLISTAGEND = :NRCHECKLISTAGEND
                AND FCM_RELACEQUIPEOPER.IDATIVO = 'S'";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql, $parametros);
    }

    public function getInscricaoParceiro($parametros)
    {
        $sql = "SELECT OPERADOR.CDOPERADOR, OPERADOR.NMOPERADOR, OPERADOR.NRPARCNEGOCIO, PARCNEGOCIO.NRINSCRICAOPARC
                FROM OPERADOR
                 JOIN PARCNEGOCIO
                    ON PARCNEGOCIO.NRPARCNEGOCIO = OPERADOR.NRPARCNEGOCIO
                WHERE PARCNEGOCIO.CDTIPOINSCRICAO = 'CPF' 
                    AND OPERADOR.IDATIVO = 'S'
                 AND PARCNEGOCIO.IDATIVO = 'S'
                 AND OPERADOR.CDOPERADOR = :CDOPERADOR";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql, $parametros);
    }
    public function getParamsGeral()
    {
        $sql = "SELECT DSURLHCM, DSIDHCM, DSSECRETHCM, DSTOKENHCM 
                  FROM PARAMGERAL";

        return $this->connection->executeQuery($sql)->fetchAllAssociative();
    }

    public function updateToken($parametros) 
    {
        $sql = "UPDATE PARAMGERAL
                   SET DSTOKENHCM = :TOKEN";

        $this->connection->executeStatement($sql, $parametros);
    }

}